using System;

namespace HogeHogeCube
{
	/// <summary>
	/// 񐮐
	/// </summary>
	public class CyclicInt
	{
		/// <summary>
		/// ŏlƍőlw肷`̃RXgN^
		/// </summary>
		/// <param name="boundary1">l̒[̒lP</param>
		/// <param name="boundary2">l̒[̒lQ</param>
		/// <param name="n">l</param>
		public CyclicInt(int boundary1, int boundary2, int n)
		{
			if(boundary1 < boundary2)
			{
				m_min = boundary1;
				m_max = boundary2;
			}
			else
			{
				m_min = boundary2;
				m_max = boundary1;
			}
			m_size = m_max - m_min + 1;

			m_n = n;
			adjust();
		}

		/// <summary>
		/// ŏl 0 ɌŒ肵Al̃TCYw肷`̃RXgN^
		/// </summary>
		/// <param name="size">l̃TCY</param>
		/// <param name="n">l</param>
		public CyclicInt(int size, int n)
		{
			m_min  = 0;
			m_max  = size - 1;
			m_size = size;

			m_n = n;
			adjust();
		}

		/// <summary>
		/// l̒
		/// </summary>
		private void adjust()
		{
			if(m_n < m_min)
			{
				m_n += ((m_min - m_n - 1) / m_size + 1) * m_size;
			}
			else if(m_n > m_max)
			{
				m_n -= ((m_n - m_max - 1) / m_size + 1) * m_size;
			}
		}

		#region Z
		/// <summary>
		/// Z
		/// </summary>
		public static CyclicInt operator+(CyclicInt n1, int n2)
		{
			CyclicInt res = (CyclicInt)n1.MemberwiseClone();
			res.m_n += n2;
			res.adjust();
			return res;
		}

		/// <summary>
		/// Z
		/// </summary>
		public static CyclicInt operator+(int n1, CyclicInt n2)
		{
			return n2 + n1;
		}

		/// <summary>
		/// Z
		/// </summary>
		public static CyclicInt operator-(CyclicInt n1, int n2)
		{
			CyclicInt res = (CyclicInt)n1.MemberwiseClone();
			res.m_n -= n2;
			res.adjust();
			return res;
		}

		/// <summary>
		/// Z
		/// </summary>
		public static CyclicInt operator-(int n1, CyclicInt n2)
		{
			CyclicInt res = (CyclicInt)n2.MemberwiseClone();
			res.m_n = n1 - res.m_n;
			res.adjust();
			return res;
		}

		/// <summary>
		/// CNg
		/// </summary>
		public static CyclicInt operator++(CyclicInt n)
		{
			if(n.m_n == n.m_max)
			{
				n.m_n = n.m_min;
			}
			else
			{
				++n.m_n;
			}
			return n;
		}

		/// <summary>
		/// fNg
		/// </summary>
		public static CyclicInt operator--(CyclicInt n)
		{
			if(n.m_n == n.m_min)
			{
				n.m_n = n.m_max;
			}
			else
			{
				--n.m_n;
			}
			return n;
		}

		/// <summary>
		/// int ւ̈ÖكLXg
		/// </summary>
		public static implicit operator int(CyclicInt n)
		{
			return n.m_n;
		}
		#endregion

		#region tB[hEvpeB
		/// <summary>
		/// l
		/// </summary>
		private int m_n;
		public int Value
		{
			get { return m_n; }
			set
			{
				m_n = value;
				adjust();
			}
		}

		/// <summary>
		/// ŏl
		/// </summary>
		private int m_min;
		public int Min { get { return m_min; } }

		/// <summary>
		/// ől
		/// </summary>
		private int m_max;
		public int Max { get { return m_max; } }

		/// <summary>
		/// l̃TCY
		/// </summary>
		private int m_size;
		#endregion
	}
}
