using System;
using System.Drawing;

namespace Draw
{
	/// <summary>
	/// ItXN[obt@\NX
	/// </summary>
	public class Offscreen
	{
		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="width">obt@̕</param>
		/// <param name="height">obt@̍</param>
		/// <param name="brushBack">wiuVinull ̏ꍇ͉hȂj</param>
		public Offscreen(int width, int height, Brush brushBack)
		{
			m_buffer    = new Bitmap(width, height);
			m_gBuffer   = Graphics.FromImage(m_buffer);
			m_brushBack = brushBack;

			fill();
		}

		/// <summary>
		/// wiFœhԂ܂
		/// </summary>
		public void fill()
		{
			if(m_brushBack != null)
			{
				m_gBuffer.FillRectangle(m_brushBack, 0, 0, m_buffer.Width, m_buffer.Height);
			}
		}

		/// <summary>
		/// TCYύX܂
		/// </summary>
		/// <param name="widthNew">V</param>
		/// <param name="heightNew">V</param>
		public void changeSize(int widthNew, int heightNew)
		{
			// TCYςȂꍇ͉Ȃ
			if(widthNew == Width && heightNew == Height)
			{
				return;
			}

			// ʂ̃obt@
			Offscreen offs = new Offscreen(widthNew, heightNew, m_brushBack);

			// փRs[
			int width  = Math.Min(Width , widthNew );
			int height = Math.Min(Height, heightNew);
			offs.Graphics.DrawImage(m_buffer, 0, 0, width, height);

			// ʂq
			m_buffer  = offs.m_buffer;
			m_gBuffer = offs.m_gBuffer;
		}

		/// <summary>
		/// TCYύX܂
		/// </summary>
		/// <param name="sizeNew">VTCY</param>
		public void changeSize(Size sizeNew)
		{
			changeSize(sizeNew.Width, sizeNew.Height);
		}

		#region tB[hEvpeB
		/// <summary>
		/// ItXN[obt@
		/// </summary>
		private Bitmap m_buffer;
		public Bitmap Buffer
		{
			get { return m_buffer; }
		}

		/// <summary>
		/// obt@TCY擾
		/// </summary>
		public Size Size
		{
			get { return new Size(Width, Height); }
		}
		public int Width
		{
			get { return m_buffer.Width; }
		}
		public int Height
		{
			get { return m_buffer.Height; }
		}

		/// <summary>
		/// ItXN[obt@̕`IuWFNg
		/// </summary>
		private Graphics m_gBuffer;
		public Graphics Graphics
		{
			get { return m_gBuffer; }
		}

		/// <summary>
		/// wiuV
		/// </summary>
		private Brush m_brushBack;
		#endregion
	}
}
